/*
 * Implementao ligada de filas utilizando apontadores para o incio
 * e o final da fila.
 *
 * Observao: o campo final s  vlido se a fila tiver pelo menos
 * um elemento.
 */

#include <stdlib.h>
#include <stdio.h>
#include "fila.h"

/* Inicia uma instncia do tipo fila */
void cria_fila(Fila* ap_fila) {
  ap_fila->inicio = NULL;
}

/* Verifica se a fila est vazia */
int fila_vazia(Fila* ap_fila) {
  return ap_fila->inicio == NULL;
}

/* Insere um elemento na fila */
void insere_fila(Fila* ap_fila, void* elem) {
  No_fila* p = (No_fila*) malloc(sizeof(No_fila));
  p->elem = elem;
  p->prox = NULL;
  if (fila_vazia(ap_fila)) 
    ap_fila->inicio = p; 
  else 
    ap_fila->fim->prox = p;
  ap_fila->fim = p;
}

/* Remove um elemento da fila */
/* Retorna 0 caso a fila esteja vazia e 1 em caso de sucesso */
int remove_fila(Fila* ap_fila, void** ap_elem) {
  if (fila_vazia(ap_fila)) {
    return 0;
  }
  No_fila* p = ap_fila->inicio;
  *ap_elem = p->elem; 
  ap_fila->inicio = p->prox;
  free(p);
  return 1;
}

/* Descarta todos os elementos da fila */
void libera_fila(Fila* ap_fila) {
  No_fila* p = ap_fila->inicio;
  while (p != NULL) {
    No_fila* q = p;
    p = p->prox;
    free(q);
  }
}
